#!/bin/bash

# $1 : le nom de l'exécutable
# $2 : le répertoire où générer le package
# Exemple : ./gen_package.sh \ou\est\le\program \ou\generer\le\package

if [ $# -lt 2 ]
then
  echo "Exemple : ./gen_package.sh \ou\est\le\program \ou\generer\le\package"
  exit
fi

CHEMIN_PACKAGE="$2"
CHEMIN_PACKAGE_LIB="$2/lib"
CHEMIN_SCRIPT="${CHEMIN_PACKAGE}/$(basename $1).sh"

# _____ Génération des répertoires et copie de l'exécutable
mkdir "$CHEMIN_PACKAGE"
mkdir "$CHEMIN_PACKAGE_LIB"
cp "$1" "$CHEMIN_PACKAGE_LIB"

# _____ Génération du script d'appel de l'exécutable
echo "#!/bin/bash" > "$CHEMIN_SCRIPT"
  # Pour pouvoir exécuter depuis un schell ou depuis un explorateur gnome
echo "if [[ \"\$(dirname \$0)\" == .* ]]" >> "$CHEMIN_SCRIPT"
echo "then CHEMIN=\"\$(pwd)/\$(dirname \$0)/lib\"" >> "$CHEMIN_SCRIPT"
echo "else CHEMIN=\"\$(dirname \$0)/lib\"" >> "$CHEMIN_SCRIPT"
echo "fi" >> "$CHEMIN_SCRIPT"
  # Appel de l'exécutable
echo "export LD_LIBRARY_PATH=\${LD_LIBRARY_PATH}:\${CHEMIN}" >> "$CHEMIN_SCRIPT"
echo "nohup \${CHEMIN}/`basename $1` &" >> "$CHEMIN_SCRIPT"
chmod u+x "$CHEMIN_SCRIPT"

# _____ Copie des librairies
ldd "${CHEMIN_PACKAGE_LIB}/$(basename $1)" | grep "=> /" | sed "s/^.*=>//" |  sed "s/(.*)//" | while read lib; do
  cp "$lib" "${CHEMIN_PACKAGE_LIB}"
done

